using MeshVR;using MVR.FileManagementSecure;using SimpleJSON;using System;using System.Collections.Generic;using System.Linq;using System.Text;using UnityEngine;using UnityEngine.UI;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;namespace PluginIdea.MR{public class Mirror : MVRScript{private Request request;public static Dictionary<string, GameObject> dic_name2Objects = new Dictionary<string, GameObject>();public static Dictionary<string, Material> dic_name2Mats = new Dictionary<string, Material>();public static Dictionary<string, Shader> dic_name2Shaders = new Dictionary<string, Shader>();private ReflectionMono reflMono;private Material targetMat;private bool isResourcesLoaded;private const string WATERSHAER_BASENAME = "PluginIdea/MirrorSurface";private GameObject rigObject;private string ShaderName{get{return isRefract.val? WATERSHAER_BASENAME + "Refract" : WATERSHAER_BASENAME;}}public override void Init(){Location.InitTData();Utils.InitUI(CreateUIElement);UIInit();DataInit();RegistBundleUnload();SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;}private Button hardResetBtn;private void RegistBundleUnload(){hardResetBtn = SuperController.singleton.mainHUD.Find("MainUICanvas/Panel/Content/TabFile/Content/Hard Reset Button").GetComponent<Button>();hardResetBtn.onClick.AddListener(UnloadBundle);}private void UnloadBundle(){if (request != null && request.assetBundle != null){request.assetBundle.Unload(false);}}private void DataInit(){string assetsBundlePath = Utils.GetPluginPath(this) + string.Format("/resources/mirror{0}.assetbundle", Utils.version);request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request abffr){GameObject[] objects = abffr.assetBundle.LoadAllAssets<GameObject>();for (int i = 0;i < objects.Length;i++){if (!dic_name2Objects.ContainsKey(objects[i].name)){dic_name2Objects.Add(objects[i].name, objects[i]);}}Material[] mats = abffr.assetBundle.LoadAllAssets<Material>();for (int i = 0;i < mats.Length;i++){if (!dic_name2Mats.ContainsKey(mats[i].name)){dic_name2Mats.Add(mats[i].name, mats[i]);}}Shader[] shaders = abffr.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_name2Shaders.ContainsKey(shaders[i].name)){dic_name2Shaders.Add(shaders[i].name, shaders[i]);}}isResourcesLoaded = true;ReApplyInit();ReApplyUIParameter();}private TextureSettings maskTextureSetting = new TextureSettings(){compress = true, linearColor = false};private TextureSettings normalTextureSetting = new TextureSettings(){compress = true, linearColor = false, isNormalMap = true};private JSONStorableBool isRefract;private JSONStorableFloat refractDistortAmount;private JSONStorableUrl shapeMaskTexURL;private JSONStorableFloat bumpMapWrapCount;private JSONStorableUrl bumpTexURL;private JSONStorableBool isRenderRateWithGame;private JSONStorableFloat customRenderRate;private JSONStorableBool isBlurRfTexture;private JSONStorableFloat blurRadius;private JSONStorableFloat blurIterateCount;private List<string> reflectLevels = new List<string>{"Low","Middle", "High", "VeryHigh", "Off"};private List<string> personStrs = new List<string>{};private JSONStorableStringChooser reflectLevelChooser;private JSONStorableFloat reflectStrengh;private JSONStorableFloat refractStrengh;private JSONStorableFloat width;private JSONStorableFloat height;private JSONStorableColor specularColor;private JSONStorableFloat smoothness;private JSONStorableFloat reflectDistortAmount;private JSONStorableFloat mainAlpha;private static JSONStorableBool isFilterActive;private static JSONStorableBool onlyPerson;private JSONStorableStringChooser personChooser;private bool ffs;private Texture maskTex,bumpTex;private Material defaultMat;public static int CullMask{get{if (isFilterActive.val && onlyPerson.val) return 1 << LayerMask.NameToLayer("Character") | 1 << LayerMask.NameToLayer("TransparentFX");else return 1 << LayerMask.NameToLayer("Default") | 1 << LayerMask.NameToLayer("TransparentFX");}}private void UIInit(){ffs = Utils.IsCerPass();if (!ffs){Utils.CC2(this);}var btn = Utils.CreateButton(this, Location.GetStr(Location.OpenMainPage), () =>{if (Location.IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false, true);btn.buttonImage.color = Color.yellow;Utils.CreateSpacer(this, 30, false);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PluginInfo), 300, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.CommonParaSubtitle), 40, false);width = Utils.CreateSliderFloat(this, Location.GetStr(Location.Width), 15f, 0f, 100, false, true);width.setCallbackFunction = OnApplySize;height = Utils.CreateSliderFloat(this, Location.GetStr(Location.Height), 15f, 0f, 100, false, true);height.setCallbackFunction = OnApplySize;reflectLevelChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.ReflectQuality), reflectLevels, false, ffs);reflectLevelChooser.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;reflMono.enabled = val != "Off";if (val == "Low"){reflMono._textureSize = 240;}else if (val == "Middle"){reflMono._textureSize = 480;}else if (val == "High"){reflMono._textureSize = 960;}else if (val == "VeryHigh"){reflMono._textureSize = 1920;}};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.FilterOptionsSubtitle), 40, false);isFilterActive = Utils.CreateToggle(this, Location.GetStr(Location.IsFilterActive), false, false, true);onlyPerson = Utils.CreateToggle(this, Location.GetStr(Location.IsOnlyPerson), false, false, true);onlyPerson.setCallbackFunction = (val)=>{OnOnlyPersonSelect();};Utils.CreateButton(this, Location.GetStr(Location.RefreshPersons), FillPersonChooser, false, true);personChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.TargetPersonSelect), new List<string>(), 0, false, true);personChooser.setCallbackFunction = (val) =>{OnOnlyPersonSelect();};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.BumpSubtitle), 40, true);bumpTexURL = Utils.CreateTexture2DChooser(this, Location.GetStr(Location.BumpMap), $"Custom/Assets/", true, normalTextureSetting, (tex) =>{if (!isResourcesLoaded) return;if (bumpTex != null) Destroy(bumpTex);bumpTex = tex;targetMat.SetTexture("_BumpMap", bumpTex);}, ffs);bumpMapWrapCount = Utils.CreateSliderFloat(this, Location.GetStr(Location.BumpMapWrapCount), 1f, 0.1f, 20, true, ffs);bumpMapWrapCount.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.SetTextureScale("_BumpMap", new Vector2(val,val));};Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () =>{Destroy(targetMat.GetTexture("_BumpMap"));bumpTexURL.Reload();}, Location.GetStr(Location.Remove), () =>{Destroy(targetMat.GetTexture("_BumpMap"));targetMat.SetTexture("_BumpMap", defaultMat.GetTexture("_BumpMap"));}, true, ffs);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.ShapeMaskSubtitle), 40, true);shapeMaskTexURL = Utils.CreateTexture2DChooser(this, Location.GetStr(Location.ShapeMaskTex), $"Custom/Assets/", true, maskTextureSetting, (tex) =>{if (!isResourcesLoaded) return;if (maskTex != null) Destroy(maskTex);maskTex = tex;targetMat.SetTexture("_AlphaMask", maskTex);}, ffs);Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () =>{Destroy(targetMat.GetTexture("_AlphaMask"));shapeMaskTexURL.Reload();}, Location.GetStr(Location.Remove), () =>{Destroy(targetMat.GetTexture("_AlphaMask"));targetMat.SetTexture("_AlphaMask", defaultMat.GetTexture("_AlphaMask"));}, true, ffs);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.RefractSubtitle), 40, true);isRefract = Utils.CreateToggle(this, Location.GetStr(Location.IsRefract), false, true, ffs);isRefract.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.shader = dic_name2Shaders[ShaderName];};refractStrengh = Utils.CreateSliderFloat(this, Location.GetStr(Location.RefractStrengh), 1f, 0f, 10f, true, ffs);refractStrengh.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.SetFloat("_RefractStrengh", val);};refractDistortAmount = Utils.CreateSliderFloat(this, Location.GetStr(Location.RefractDistortAmount), 0f, 0f, 100, true, ffs);refractDistortAmount.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.SetFloat("_RefractDistortStrengh", val);};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.ReflectionSubtitle), 40, true);isRenderRateWithGame = Utils.CreateToggle(this, Location.GetStr(Location.IsRenderRateWithGame), false, true, true);isRenderRateWithGame.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;reflMono.isRenderRateFollowGame = val;};customRenderRate = Utils.CreateSliderInt(this, Location.GetStr(Location.CustomRenderRate), 24, 0, 60, true, ffs);customRenderRate.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;reflMono.customRenderRate = val;};isBlurRfTexture = Utils.CreateToggle(this, Location.GetStr(Location.IsBlurReflectTexture), true, true, true);isBlurRfTexture.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;reflMono.isBlur = val;};reflectStrengh = Utils.CreateSliderFloat(this, Location.GetStr(Location.ReflectStrengh), 1f, 0f, 10f, true, true);reflectStrengh.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.SetFloat("_ReflectStrengh", val);};reflectDistortAmount = Utils.CreateSliderFloat(this, Location.GetStr(Location.ReflectDistortAmount), 0f, 0f, 100, true, ffs);reflectDistortAmount.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.SetFloat("_ReflectDistortStrengh", val);};blurIterateCount = Utils.CreateSliderInt(this, Location.GetStr(Location.BlurIterateCount), 2, 1, 5, true, ffs);blurIterateCount.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;reflMono.iteration = (int)val;};blurRadius = Utils.CreateSliderFloat(this, Location.GetStr(Location.BlurRadius), 0.26f, 0f, 1f, true, ffs);blurRadius.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;reflMono.BlurRadius = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.MainLookSubtitle), 40, false);mainAlpha = Utils.CreateSliderFloat(this, Location.GetStr(Location.MainAlpha), 0f, 0f, 1, true, ffs);mainAlpha.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.SetColor("_Color", new Color(0,0,0,val));};smoothness = Utils.CreateSliderFloat(this, Location.GetStr(Location.SmoothNess), 0.6f, 0f, 1f, false, ffs);smoothness.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;targetMat.SetFloat("_Smoothness", val);};specularColor = Utils.CreateColor(this, Location.GetStr(Location.SpecularColor), Color.black, false);specularColor.setCallbackFunction = (h, s, v) =>{if (!isResourcesLoaded) return;targetMat.SetColor("_SpecularColor", Color.HSVToRGB(h, s, v));};}private void OnSceneLoaded(){if (!isFilterActive.val) return;if (onlyPerson.val){SuperController.singleton.StartCoroutine(Utils.WaitTimeCall(1.5f, () =>{FillPersonChooser();FlagPerson(onlyPerson.val);}));}}private void FillPersonChooser(){personStrs = SuperController.singleton.GetAtoms().Where(x => x.type == "Person").Select(x => x.uid).ToList();personStrs.Insert(0, "All");personChooser.choices = personStrs;}private void OnOnlyPersonSelect(){if (!isFilterActive.val) return;FlagPerson(onlyPerson.val);}private void FlagPerson(bool isOnlyPerson){if (string.IsNullOrEmpty(personChooser.val)) return;int charactorLayer = LayerMask.NameToLayer("Character");int defaultLayer = LayerMask.NameToLayer("Default");if (isOnlyPerson){if (!string.IsNullOrEmpty(personChooser.val)){SuperController.singleton.GetAtoms().Where(x => x.type == "Person").ToList().ForEach(s =>{if (personChooser.val == "All"){FlagPersonMesh(s, charactorLayer);}else{if (s.uid == personChooser.val){FlagPersonMesh(s, charactorLayer);}else{FlagPersonMesh(s, defaultLayer);}}});}}else{SuperController.singleton.GetAtoms().Where(x => x.type == "Person").ToList().ForEach(s =>{FlagPersonMesh(s, defaultLayer);});}}private void FlagPersonMesh(Atom person, int layer){var geo = person.transform.Find("rescale2/geometry");Utils.SetLayer(geo, layer);}private void OnApplySize(float val){if (!isResourcesLoaded) return;rigObject.transform.localScale = new Vector3(width.val * 0.1f, 1, height.val * 0.1f);}private void ReApplyInit(){var parent = containingAtom.reParentObject.Find("object/rescaleObject");rigObject = GameObject.CreatePrimitive(PrimitiveType.Plane);rigObject.transform.SetParent(parent);rigObject.transform.localPosition = Vector3.zero;rigObject.transform.localEulerAngles = Vector3.zero;rigObject.layer = LayerMask.NameToLayer("Water");reflMono = Utils.GetSafeComponent<ReflectionMono>(rigObject);reflMono.Init();Renderer renderer = rigObject.GetComponent<Renderer>();renderer.shadowCastingMode = UnityEngine.Rendering.ShadowCastingMode.Off;targetMat = renderer.material;targetMat.color = Color.black;targetMat.shader = dic_name2Shaders[ShaderName];defaultMat = new Material(targetMat);OnApplySize(1);rigObject.transform.localPosition = Vector3.zero;FillPersonChooser();}protected void ReApplyUIParameter(){reflectDistortAmount.setCallbackFunction(reflectDistortAmount.val);isRenderRateWithGame.setCallbackFunction(isRenderRateWithGame.val);customRenderRate.setCallbackFunction(customRenderRate.val);specularColor.setCallbackFunction(specularColor.val.H, specularColor.val.S, specularColor.val.V);smoothness.setCallbackFunction(smoothness.val);reflectLevelChooser.setCallbackFunction(reflectLevelChooser.val);isBlurRfTexture.setCallbackFunction(isBlurRfTexture.val);blurRadius.setCallbackFunction(blurRadius.val);isRefract.setCallbackFunction(isRefract.val);refractDistortAmount.setCallbackFunction(refractDistortAmount.val);mainAlpha.setCallbackFunction(mainAlpha.val);shapeMaskTexURL.Reload();bumpTexURL.Reload();bumpMapWrapCount.setCallbackFunction(bumpMapWrapCount.val);blurIterateCount.setCallbackFunction(blurIterateCount.val);reflectStrengh.setCallbackFunction(reflectStrengh.val);refractStrengh.setCallbackFunction(refractStrengh.val);width.setCallbackFunction(width.val);height.setCallbackFunction(height.val);onlyPerson.setCallbackFunction(onlyPerson.val);}private void OnDestroy(){if (hardResetBtn != null){hardResetBtn.onClick.RemoveListener(UnloadBundle);}SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;Destroy(rigObject);Utils.DestroyUI();}}}